=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2006-03-09 00:24:48 +0000
+++ bzrlib/msgeditor.py	2006-04-28 09:50:03 +0000
@@ -1,6 +1,4 @@
-# Bazaar-NG -- distributed version control
-
-# Copyright (C) 2005 by Canonical Ltd
+# Copyright (C) 2005, 2006 by Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -42,10 +40,12 @@
     except KeyError:
         pass
 
-    if os.name == "nt":
-        yield "notepad.exe"
-    elif os.name == "posix":
-        yield "/usr/bin/vi"
+    if sys.platform == 'win32':
+        for editor in 'wordpad.exe', 'notepad.exe':
+            yield editor
+    else:
+        for editor in ['vi', 'pico', 'nano', 'joe']:
+            yield editor
 
 
 def _run_editor(filename):
@@ -55,8 +55,8 @@
         try:
             x = call(edargs + [filename])
         except OSError, e:
-           # ENOENT means no such editor
-           if e.errno == errno.ENOENT:
+           # We're searching for an editor, so catch safe errors and continue
+           if e.errno in (errno.ENOENT, ):
                continue
            raise
         if x == 0:
@@ -65,8 +65,9 @@
             continue
         else:
             break
-    raise BzrError("Could not start any editor. "
-                   "Please specify $EDITOR or use ~/.bzr.conf/editor")
+    raise BzrError("Could not start any editor.\nPlease specify one with:\n"
+                   " - $BZR_EDITOR\n - editor=/some/path in %s\n - $EDITOR" % \
+                    config.config_filename())
 
 
 DEFAULT_IGNORE_LINE = "%(bar)s %(msg)s %(bar)s" % \

